# Emmy version 1.0.0
# EmmyProbabilityDeclaration.py
# by Antoine Rauzy
# Copyrights (c) 2019 AltaRica Association
#
# This file is part of Emmy, a pedagogical stochastic simulator.
# Emmy is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Emmy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Emmy.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Creator
# 3) Access methods

# 1) Imported modules
# -------------------

from S2MLCore import *

from EmmyType import *

# 2) Parameters
# -------------

class EmmyProbabilityDeclaration(S2MLElement):
  def __init__(self, variablePath, constant, distribution, container):
    S2MLElement.__init__(self, EmmyType.PROBABILITY_DECLARATION, container)
    self._variablePath = variablePath
    self._variable = None
    self._constant = constant
    self._distribution = distribution
    self._index = 0

# 3) Access methods
# -----------------

  def GetVariablePath(self):
    return self._variablePath

  def GetVariable(self):
    return self._variable
  def SetVariable(self, variable):
    self._variable = variable

  def GetConstant(self):
    return self._constant

  def GetDistribution(self):
    return self._distribution

  def GetIndex(self):
    return self._index
  def SetIndex(self, index):
    self._index = index
