# S2MLCore version 1.0.0
# S2MLStochasticOperator.py
# by Antoine Rauzy
# Copyrights (c) 2018 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Operators

# 1) Imported modules
# -------------------

import string
import sys
import re
import math
import random

from S2MLType import *
from S2MLMetaModel import *
from S2MLDomains import *

# 2) Operators
# ------------

class S2MLStochasticOperator:
  MANY = -1
  def __init__(self, type, keywordCode, minimumNumberOfArguments, maximumNumberOfArguments, calculate):
    self._type = type
    self._keywordCode = keywordCode
    self._minimumNumberOfArguments = minimumNumberOfArguments
    self._maximumNumberOfArguments = maximumNumberOfArguments
    self._calculate = calculate

  def GetType(self):
    return self._type

  def GetKeywordCode(self):
    return self._keywordCode

  def GetMinimumNumberOfArguments(self):
    return self._minimumNumberOfArguments

  def GetMaximumNumberOfArguments(self):
    return self._maximumNumberOfArguments

  def GetCalculate(self):
    return self._calculate

  def IsEmpiricalDistribution(self):
    return self.GetType()==S2MLType.PIECEWISE_UNIFORM_DEVIATE_EXPRESSION \
      or self.GetType()==S2MLType.STEPWISE_DEVIATE_EXPRESSION \
      or self.GetType()==S2MLType.PIECEWISE_UNIFORM_DISTRIBUTION_EXPRESSION \
      or self.GetType()==S2MLType.STEPWISE_DISTRIBUTION_EXPRESSION

